/* bcopalav.c - Manuteno do banco de palavras */

#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "tela.h"
#include "manutarq.h"
#include "bcopalav.h"
#include "estrdado.h"

extern char palavras [20] [TAM_PAL];
extern int classes [20];
extern int num_pal;


void tela_palavra (void)
{

  gotoxy (10, 6);
  cprintf ("Palavra:");
  gotoxy (38, 6);
  putch (':');
  gotoxy (10, 8);
  cprintf ("AJ - Adjetivos ");
  gotoxy (10, 9);
  cprintf ("AV - Advrbios");
  gotoxy (10, 10);
  cprintf ("QU - Quantificadores");
  gotoxy (10, 11);
  cprintf ("SN - Nomes prprios");
  gotoxy (10, 12);
  cprintf ("NC - Nomes comuns");
  gotoxy (10, 13);
  cprintf ("PA - Preposies formadoras de advrbios");
  gotoxy (10, 14);
  cprintf ("PN - Preposies que com nomes comuns formam adjetivos");
  gotoxy (10, 15);
  cprintf ("PS - Preposies que com nomes prprios formam adjetivos");
  gotoxy (10, 16);
  cprintf ("VC - Verbos copulativos");
  gotoxy (10, 17);
  cprintf ("VI - Verbos intransitivos");
  gotoxy (10, 18);
  cprintf ("VT - Verbos transitivos");
  gotoxy (10, 20);
  cprintf ("Classe:  :");

}


void tela_sentenca (void)
{

  gotoxy (1, 10);
  cprintf ("Sentena a ser reconhecida.");
  gotoxy (1, 12);
  putch (':');
  gotoxy (80, 12);
  putch (':');

}

int pega_sentenca (char *sentenca)
{

  int entrada,
      cont = 0;

  do {
    gotoxy (2, 12);
    do {
      do {
	entrada = getch ();
	if (entrada == '\b')
	  if (cont > 0) {
	    cprintf ("\b \b");
	    cont--;
	  }
      }
      while (!isalpha (entrada) && entrada != ENTER && entrada != ESPACO);
      if (entrada == ENTER)
	sentenca [cont] = NULO;
      else
      if (cont < 78) {
	  entrada = sentenca [cont++] = toupper (entrada);
	  putch (entrada);
      }
    } while (entrada != ENTER);
  } while (!strcmp (sentenca, ""));

}


int pega_palavra (char *palavra)
{

  int entrada,
      cont = 0;

  do {
    gotoxy (18, 6);
    do {
      do {
        entrada = getch ();
        if (entrada == '\b')
          if (cont > 0) {
            cprintf ("\b \b");
              cont--;
	  }
    }
    while (!isalpha (entrada) && entrada != ENTER)
      ;
    if (entrada == ENTER)
      palavra [cont] = NULO;
    else if (cont < 20) {
      entrada = palavra [cont++] = toupper (entrada);
      putch (entrada);
    }
    } while (entrada != ENTER);
  } while (!strcmp (palavra, ""));

}


int pega_classe (void)
{
  int entrada,
      cont;
  char classe [5];

  do {
    cont = 0;
    gotoxy (17, 20);
    cprintf ("  \b\b");
    do {
      do {
	entrada = getch ();
	if (entrada == '\b')
	  if (cont > 0) {
	    cprintf ("\b \b");
	    cont--;
	  }
      }
      while (!isalpha (entrada) && entrada != ENTER);
      if (entrada == ENTER)
	classe [cont] = NULO;
      else
      if (cont < 2) {
	  entrada = classe [cont++] = toupper (entrada);
	  putch (entrada);
      }
    } while (entrada != ENTER);
    if (!strcmp (classe, "AJ"))
      return ADJ;
    if (!strcmp (classe, "AV"))
      return ADV;
    if (!strcmp (classe, "QU"))
      return QU;
    if (!strcmp (classe, "SN"))
      return SN;
    if (!strcmp (classe, "NC"))
      return NC;
    if (!strcmp (classe, "PA"))
      return PADV;
    if (!strcmp (classe, "PN"))
      return PNC;
    if (!strcmp (classe, "PS"))
      return PSN;
    if (!strcmp (classe, "VC"))
      return VC;
    if (!strcmp (classe, "VI"))
      return VI;
    if (!strcmp (classe, "VT"))
      return VT;
  } while (TRUE);
}

void incluir_palavra (void)
{
  int arqdados;
  char buffer_arq [40];
  char palavra [25];
  int classe;

  tela_principal ();

  if (abre (&arqdados, ARQ_DADOS, "a") == ERRO) {
    int resp;

    resp = mensagem ("O arquivo de palavras nao existe, criar ?", S_OU_N);
    if (resp == SIM)
      abre (&arqdados, ARQ_DADOS, "create");
    else
      finaliza ();
  }

  tela_palavra ();

  pega_palavra (palavra);

  classe = pega_classe ();

  grava_reg (arqdados, palavra, classe);

  close (arqdados);
}

void reconhecer (void)
{
  char sentenca [100];
  int arqdados,
      cont = 0,
      cont_pal = 0;

  tela_principal ();

  if (abre (&arqdados, ARQ_DADOS, "r") == ERRO) {
    mensagem ("O arquivo de palavras nao existe.", ESP_ENTER);
    finaliza ();
  }

  tela_sentenca ();

  pega_sentenca (sentenca);

  num_pal = 0;
  do {
    while (!isalpha (sentenca [cont]))
      cont++;
    while (isalpha (sentenca [cont]))
      palavras [num_pal] [cont_pal++] = sentenca [cont++];
    palavras [num_pal] [cont_pal] = NULO;
    if ((classes [num_pal] =
	 pesquisa_reg (arqdados, palavras [num_pal])) == ERRO) {
      mensagem ("Palavra nao encontrada, abandonar reconh.", ESP_ENTER);
      finaliza ();
    }
    num_pal++;
    cont_pal = 0;
  } while (sentenca [cont] != NULO);

}


