/* manutarq.c - Rotinas para manuteno dos arquivos de dados. */

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include "manutarq.h"
#include "bcopalav.h"

int abre (int *fd, char *arq, char *modo)
{
  int oflag = 0;

  if (!strcmp (modo, "r"))
    oflag = O_RDONLY;
  else
    if (!strcmp (modo, "w"))
      oflag = O_WRONLY;
    else
      if (!strcmp (modo, "r+w"))
	oflag = O_RDWR;
      else
        if (!strcmp (modo, "a"))
	  oflag = O_APPEND | O_WRONLY;
        else
          if (!strcmp (modo, "create")) {
	    if ((*fd = _creat (arq, FA_ARCH)) == ERRO)
	      return (ERRO);
            return (OK);
	  }

  if ((*fd = open (arq, oflag)) == ERRO)
    return (ERRO);
}

void grava_reg (int fd, char *palavra, int classe)
{
  int cont;
  char buffer [100];
  char strclasse [10];
  int dentro = TRUE;


  for (cont = 0; cont < TAM_REG_PAL; cont++) {
    if (palavra [cont] == NULO)
      dentro = FALSE;
    if (dentro)
      buffer [cont] = palavra [cont];
    else
      buffer [cont] = ' ';
  }

  itoa (classe, strclasse, 10);

  for (cont = 0; cont < strlen (strclasse); cont++)
    buffer [25 + cont] = strclasse [cont];

  write (fd, buffer, TAM_REG_PAL);

}

int pesquisa_reg (int fd, char* palavra)
{

  int lido;
  char buffer [256],
       strclasse [30];

  lseek (fd, 0, SEEK_SET);

  do {
    if ((lido = read (fd, buffer, TAM_REG_PAL)) != 0) {
      if (!strncmp (buffer, palavra, strlen (palavra))) {

	int cont = 0,
	    cont_classe = 0;

	while (!isdigit (buffer [++cont]))
	;
	while (isdigit (buffer [cont]))
	  strclasse [cont_classe++] = buffer [cont++];
	strclasse [cont_classe] = NULO;
	return atoi (strclasse);
      }
    }
  } while (lido != 0);
  return ERRO;
}

