/* tela.c - rotinas de manuseamento de telas */

#include "tela.h"
#include <conio.h>

void moldura (int x1, int y1, int x2, int y2, int tipo)
{
  int contador;

  gotoxy (x1, y1);  /* Escolha caracter superior esquerdo.*/
  switch (tipo) {
    case 0: break;
    case 1: cprintf ("%c",201);
	    break;
    case 2: cprintf ("%c",177);
	    break;
    case 3: cprintf ("%c",214);
	    break;
    case 4: cprintf ("%c",213);
	    break;
    case 5: cprintf ("%c",176);
	    break;
    case 6: cprintf ("%c",218);
	    break;
    case 7: cprintf ("%c",178);
	    break;
    case 8: cprintf ("%c",219);
	    break;
  }

  gotoxy (x2, y1);  /* Escolha caracter superior direito.*/
  switch (tipo) {
    case 0: break;
    case 1: cprintf ("%c",187);
	    break;
    case 2: cprintf ("%c",177);
	    break;
    case 3: cprintf ("%c",183);
	    break;
    case 4: cprintf ("%c",184);
	    break;
    case 5: cprintf ("%c",176);
	    break;
    case 6: cprintf ("%c",191);
	    break;
    case 7: cprintf ("%c",178);
	    break;
    case 8: cprintf ("%c",219);
	    break;
  }

  gotoxy (x1,y2);  /* Escolha caracter inferior esquerdo.*/
  switch (tipo) {
    case 0: break;
    case 1: cprintf ("%c",200);
	    break;
    case 2: cprintf ("%c",177);
	    break;
    case 3: cprintf ("%c",211);
	    break;
    case 4: cprintf ("%c",212);
	    break;
    case 5: cprintf ("%c",176);
	    break;
    case 6: cprintf ("%c",192);
	    break;
    case 7: cprintf ("%c",178);
	    break;
    case 8: cprintf ("%c",219);
	    break;
  }

  gotoxy (x2, y2);  /* Escolha caracter inferior direito.*/
  switch (tipo) {
    case 0: break;
    case 1: cprintf ("%c",188);
	    break;
    case 2: cprintf ("%c",177);
	    break;
    case 3: cprintf ("%c",189);
	    break;
    case 4: cprintf ("%c",190);
	    break;
    case 5: cprintf ("%c",176);
	    break;
    case 6: cprintf ("%c",217);
	    break;
    case 7: cprintf ("%c",178);
	    break;
    case 8: cprintf ("%c",219);
	    break;
  }

  for (contador=(y1+1); contador<y2; contador++) {
    gotoxy (x1, contador);  /* Linha vertical esquerda. */
    switch (tipo) {
      case 0: break;
      case 1: cprintf ("%c",186);
	      break;
      case 2: cprintf ("%c",177);
	      break;
      case 3: cprintf ("%c",186);
	      break;
      case 4: cprintf ("%c",179);
	      break;
      case 5: cprintf ("%c",176);
	      break;
      case 6: cprintf ("%c",179);
	      break;
      case 7: cprintf ("%c",178);
	      break;
      case 8: cprintf ("%c",219);
	      break;
    }

    gotoxy (x2, contador);  /* Linha vertical direita. */
    switch (tipo) {
      case 0: break;
      case 1: cprintf ("%c",186);
	      break;
      case 2: cprintf ("%c",177);
	      break;
      case 3: cprintf ("%c",186);
	      break;
      case 4: cprintf ("%c",179);
	      break;
      case 5: cprintf ("%c",176);
	      break;
      case 6: cprintf ("%c",179);
	      break;
      case 7: cprintf ("%c",178);
	      break;
      case 8: cprintf ("%c",219);
	      break;
    }
  }

  for (contador=(x1+1); contador<x2; contador++) {
    gotoxy  (contador, y1);  /* Linha horizontal superior. */
    switch (tipo) {
      case 0: break;
      case 1: cprintf ("%c",205);
	      break;
      case 2: cprintf ("%c",177);
	      break;
      case 3: cprintf ("%c",196);
	      break;
      case 4: cprintf ("%c",205);
	      break;
      case 5: cprintf ("%c",176);
	      break;
      case 6: cprintf ("%c",196);
	      break;
      case 7: cprintf ("%c",178);
	      break;
      case 8: cprintf ("%c",219);
	      break;
    }

    gotoxy (contador, y2);  /* Linha direita. */
    switch (tipo)
    {
      case 0: break;
      case 1: cprintf ("%c",205);
	      break;
      case 2: cprintf ("%c",177);
	      break;
      case 3: cprintf ("%c",196);
	      break;
      case 4: cprintf ("%c",205);
	      break;
      case 5: cprintf ("%c",176);
	      break;
      case 6: cprintf ("%c",196);
	      break;
      case 7: cprintf ("%c",178);
	      break;
      case 8: cprintf ("%c",219);
	      break;
    }
  }
}


int mensagem (char *mensag, int com)
{
  int resposta;

  switch (com) {
    case S_OU_N: {
      int cont;

      gotoxy (13, 23);
      cprintf (mensag);
      cprintf (" (S/N): ");
      resposta = pega_s_ou_n ();
      gotoxy (13, 23);
      for (cont = 0; cont < 65; cont++)
	putch (' ');
      return resposta;
    }
    case ESP_ENTER: {
      int cont;

      gotoxy (13, 23);
      cprintf (mensag);
      cprintf (" <ENTER>: ");
      espera_enter ();
      gotoxy (13, 23);
      for (cont = 0; cont < 65; cont++)
	putch (' ');
      return 0;
    }
  }
}

void tela_principal (void)
{
  int cont;
  clrscr ();

  textcolor (GREEN);
  moldura (1, 1, 80, 4, DUPLO); /* Superior (Titulo) */

  textcolor (RED);
  moldura (1, 22, 80, 24, SIMPLES); /* Inferior (Mensagens) */

  textcolor (LIGHTGRAY);

  gotoxy (29, 2);
  cprintf ("Reconhecedor de Sentenas");

  gotoxy (3, 3);
  cprintf ("Prof: Jos Borges Neto");

  gotoxy (61, 3);
  cprintf ("Equipe: 2o Sem. 92");

  gotoxy (3, 23);
  cprintf ("Mensagem:");

}

char menu (void)
{
  char entrada;

  textcolor (BLUE);
  moldura (20, 7, 60, 15, DUPLO_HORIZONTAL);

  textcolor (LIGHTGRAY);
  gotoxy (28, 9);
  cprintf ("1 - Banco de palavras");
  gotoxy (28, 11);
  cprintf ("2 - Reconhecer sentena");
  gotoxy (28, 13);
  cprintf ("3 - Sair");

  textcolor (BLUE);
  moldura (25, 17, 55, 19, DUPLO_VERTICAL);

  textcolor (LIGHTGRAY);
  gotoxy (35, 18);
  cprintf ("Opo:");

  do {
    gotoxy (42, 18);
    entrada = getch ();
  } while (entrada != BANCO_PALAVRAS &&
	   entrada != RECONHECER &&
	   entrada != SAIR);
  putch (entrada);

  return entrada;
}

void espera_enter (void)
{
  int col = wherex (),
      lin = wherey ();

  char entrada;

  do {
    gotoxy (col, lin);
    entrada = getch ();
  } while (entrada != ENTER);
}


int pega_s_ou_n (void)
{
  int col = wherex (),
      lin = wherey ();

  char entrada;

  do {
    gotoxy (col, lin);
    entrada = getch ();
  } while (entrada != 'S' && entrada != 's' &&
	   entrada != 'N' && entrada != 'n');

  if ((entrada == 'S') || (entrada == 's'))
    return SIM;
  else
    return NAO;

}

void finaliza (void)
{
  clrscr ();
  cprintf ("Fim: Reconhecedor de sentenas\n\r");
  exit (0);
}

char menu_banco_palavras (void)
{
  char entrada;

  textcolor (BLUE);
  moldura (10, 7, 70, 15, DUPLO_HORIZONTAL);

  textcolor (LIGHTGRAY);
  gotoxy (13, 9);
  cprintf ("1 - Incluir palavra");
  gotoxy (13, 11);
  cprintf ("2 - Excluir palavra");
  gotoxy (13, 13);
  cprintf ("3 - Alterar palavra");
  gotoxy (38, 9);
  cprintf ("4 - Consultar palavra");
  gotoxy (38, 11);
  cprintf ("5 - Listar o banco de palavras");
  gotoxy (38, 13);
  cprintf ("6 - Retornar");

  textcolor (BLUE);
  moldura (25, 17, 55, 19, DUPLO_VERTICAL);

  textcolor (LIGHTGRAY);
  gotoxy (35, 18);
  cprintf ("Opo:");

  do {
    gotoxy (42, 18);
    entrada = getch ();
  } while (entrada != INCLUIR_PALAVRA &&
	   entrada != EXCLUIR_PALAVRA &&
	   entrada != ALTERAR_PALAVRA &&
	   entrada != CONSULTAR_PALAVRA &&
	   entrada != LISTAR_BANCO &&
	   entrada != RETORNAR);
  putch (entrada);

  return entrada;
}

void principal (void)
{
  char princ_opcao;

  do {

    tela_principal ();

    princ_opcao = menu ();

    switch (princ_opcao) {

      case BANCO_PALAVRAS: {
	char banco_opcao;

	do {
	  tela_principal ();
	  banco_opcao = menu_banco_palavras ();
	  switch (banco_opcao) {
	    case INCLUIR_PALAVRA:
	      incluir_palavra ();
	      break;
	    case EXCLUIR_PALAVRA: break;
	    case ALTERAR_PALAVRA: break;
	    case CONSULTAR_PALAVRA: break;
	    case LISTAR_BANCO: break;
	  }
	} while (banco_opcao != RETORNAR);
	break;
      }

      case RECONHECER:
	reconhecer ();
	gera_todos_os_niveis ();
	break;
    }

  } while (princ_opcao != SAIR);

  finaliza ();
}

void main (void)
{
  principal ();
}